



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>webpack打包生成多个vendor的配置方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">webpack打包生成多个vendor的配置方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 03:26:23 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>用webpack打包项目的时候，一般喜欢把一些公用的库打包的vendor.js里面，比如像react，react-router，redux等。</p>
<div>随着引入的库越来越多，vendor文件也变得越来越大，于是考虑打包成两个vendor，把和react相关的库打包成一个vendor，其他的库打包成另外一个vendor。按照webpack的文档开始配置，需要注意有两个比较坑的地方。</div>
<div>参考配置：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">...<br />
entry: {<br />
    "vendor1": ["react", "react-dom", "react-router", "react-router-redux", "react-redux", "redux"],<br />
    "vendor2": ["crypto-js", "fastclick"],<br />
    "app": "./js/index.js"<br />
},<br />
...<br />
plugins: [<br />
    new webpack.optimize.CommonsChunkPlugin({<br />
        names: ["vendor2","vendor1"],<br />
        minChunks: Infinity<br />
    })<br />
],<br />
...</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<div>第一个要注意的地方，在CommonsChunkPlugin里面，vender的顺序要反着来，总之，要和加载顺序相反。比如你想按vendor1，vendor2的顺序加载，entry里面写的是vendor1，vendor2，在CommonsChunkPlugin里面要写vendor2，vendor1。</div>
<div>&nbsp;</div>
<div>第二个要注意的地方，output.filename一定不要写死了，要配置成可替换的，类似filename: '[name].js'形式。</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>参考链接：</div>
<div><a href="https://github.com/webpack/webpack/tree/master/examples/two-explicit-vendor-chunks" rel="external nofollow noreferrer">https://github.com/webpack/webpack/tree/master/examples/two-explicit-vendor-chunks</a></div>
<div><a href="https://github.com/webpack/webpack/issues/1016" rel="external nofollow noreferrer">https://github.com/webpack/webpack/issues/1016</a></div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96mjgy8.html">Spring-IOC－BeanFactory</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx6dydq.html">从Elo Rating System谈到层次分析法</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxz4kj8.html">c&num;中高效的excel导入sqlserver的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1d315q.html">QT 数据库编程三</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde1oe09.html">careercup-数组和字符串1&period;5</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7my7lxq.html">android 随手记 自定义广播通知栏</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmrr409.html">Jenkins学习之&mdash;&mdash;&lpar;3&rpar;将项目发送到tomcat</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmgjn69.html">（原&plus;译）LUA调用C函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdjylr8.html">android入门&mdash;&mdash;UI&lpar;3&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95003pv8.html">spring html5 拖拽上传多文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7znp4j9.html">【R】正态检验与R语言</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojozg5q.html">700名黑客无法攻破Trillium安全防护软件 欲以网络安全险获利</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1mprjq.html">maven jsp out&period;print&lpar;&rpar;request&period;getParameter&lpar;&rpar; 爆红</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5dg3eq.html">python日常小计</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvn2gj8.html">html之css选择器学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o10ogeq.html">ltp-ddt的makefile结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1ooj69.html">使用 urllib 进行身份验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1ovve9.html">C&plus;&plus;空类</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp2l379.html">11&lowbar;Java面向对象&lowbar;第11天（接口、多态）&lowbar;讲义</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppojoz9.html">BZOJ4025&colon; 二分图【线段树分治】【带撤销的并查集】</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95gmjo0q.html">Hadoop生产环境配置文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rjp039.html">python django基础一web框架的本质</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e45wrk9.html">PHP中的表单传值</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5y7odq.html">windows环境配置计划任务让weblogic的servers开机启动【原】</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1nvjg9.html">WebStorm记录&lpar;2&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9607lm49.html">Elasticsearch 集群 单服务器 超级详细教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wd3rrq.html">Part-Six</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7oljy18.html">eventproxy 介绍这款好用的工具，前端事件式编程的思维</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e452pe9.html">matlab二维绘图学习摘要</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv5p6z8.html">&lbrack;C&plus;&plus;&rsqb;PAT乙级1002&period;写出这个数&lpar;20&sol;20&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
